#define _CRT_SECURE_NO_WARNINGS

#include <string.h>
#include <stdlib.h>

#include "object.h"
#include "Attribute.h"
#include "LandscapeObject.h"
#include "RelationInstance.h"
#include "LandscapeObject3D.h"
#include "LandscapeClassObject.h"
#include "EntityClass.h"
#include "RelationClass.h"
#include "EntityInstance.h"

CEntityInstance::CEntityInstance(CEntityClass *parentClassP, const char *idP) 
{
	m_srcRelListP  = 0; 
	m_dstRelListP  = 0; 
	m_nextInOrderP = 0;
	m_lineno       = NoLineno;
	m_fullpathP    = 0;
	setParentClass(parentClassP);
	m_nextInClassP                   = parentClassP->m_entityInstancesP;
	parentClassP->m_entityInstancesP = this;
	m_visited                        = 0;
	setId(idP);
}

void 
CEntityInstance::putAttribute(const char *idP, const char *valueP)
{
	if (!strcmp(idP, "label")) {
		m_labelP = valueP;
		return;
	}
	if (!strcmp(idP, "lineno")) {
		m_lineno = atoi(valueP);
		return;
	}
	if (!strcmp(idP, "file")) {
		m_fullpathP = valueP;
	}
//	CLandscapeObject3D::putAttribute(idP, valueP);
}

CEntityClass *
CEntityInstance::getEntityClass(void) const
{
	return (CEntityClass *) getParentClass();
}

const char *
CEntityInstance::getClassLabel()
{
	return getEntityClass()->getLabel();
}

CRelationInstance *
CEntityInstance::getSrcRelList(void) const
{
	return m_srcRelListP;
}

CRelationInstance *
CEntityInstance::getDstRelList(void) const
{
	return m_dstRelListP;
}

CRelationInstance *
CEntityInstance::getRelationTo(CRelationClass *rcP, CEntityInstance *dstP) 
{
	CRelationInstance *riP;

	for (riP = m_srcRelListP; riP; riP = riP->m_next_srcP) {
		if (riP->getRelationClass() == rcP) {
			if (riP->m_dstP == dstP) {
				return riP;
	}	}	}
	return 0;
}

int
CEntityInstance::buildPath(char **bufferPP, int load)
{
	CRelationInstance	*riP;
	CRelationClass		*rcP;
	const char			*labelP;
	CEntityInstance		*srcP;
	const char			*P;
	char				*bufferP;
	int					ret;

	for (riP = m_dstRelListP; riP; riP = riP->m_next_dstP) {
		rcP    = riP->getRelationClass();
		labelP = rcP->getId();
		if (!strcmp(labelP, "contain")) {
			srcP = riP->m_srcP;
			ret     = srcP->buildPath(bufferPP, load);
			bufferP = *bufferPP;
			if (ret) {
				if (load) {
					*bufferP = '/';
				}
				++bufferP;
			}
			P = srcP->getLabel();
			if (load) {
				strcpy(bufferP, P);
			}
			bufferP  += strlen(P);
			*bufferPP = bufferP;
			return(1);
	}	}
	return(0);
}
